package body Linked_List is

   function Search (L : in List) return Position is
      J : Extended_Index;
      R : Position;
      N : Node;

   begin
      J := L.Head;
      R := Pos_Zero;

      while J /= No_Index loop
         --# assert J /= No_Index and Nth (L, R) = J and
         --#        R < List_Length (L) and
         --#        not Contains (Content_First_N (L, R), 0);

         N := L.Raw(J);

         exit when N.Value = 0;

         J := N.Next;
         R := R + 1;
      end loop;

      return R;
   end Search;

end Linked_List;
