package Sum_Max is
   
   type Nat_Base is range 0 .. 1_000_000;
   subtype Nat is Nat_Base range 0 .. 10_000;
   subtype Length is Nat_Base range 0 .. 100;
   subtype Index is Length range 1 .. 100;
   type Nat_Array is array (Index range <>) of Nat;
   
   procedure Compute
     (N   : in  Length;
      A   : in  Nat_Array;
      Sum : out Nat_Base;
      Max : out Nat);
   --# derives Sum, Max from A, N;
   --# pre  A'First = 1 and A'Last = N;
   --# post Sum <= N * Max;
   
end Sum_Max;
		      
   
