with Ada.Text_IO; use Ada.Text_IO;
with Injection;   use Injection;

procedure Main is
   N : constant Length := 10;
   A : constant Permutation := (9, 3, 8, 2, 7, 4, 0, 1, 5, 6);

   subtype Zero_To_Nine is Index range 0 .. N-1;
   B : Permutation (Zero_To_Nine);

   procedure Print_Permutation (P : Permutation) is
   begin
      for J in P'Range loop
         Put_Line (Index'Image (P(J)));
      end loop;
   end Print_Permutation;
begin
   Invert (N, A, B);
   Put_Line ("A ="); Print_Permutation (A);
   Put_Line ("B ="); Print_Permutation (B);
end Main;

