with Ada.Text_IO; use Ada.Text_IO;
with Linked_List; use Linked_List;

procedure Main is
   L : constant List :=
     (Head => 1,
      Raw  => (1      => (Value => 1, Next => 2),
               2      => (Value => 2, Next => 5),
               3      => (Value => 5, Next => 0),
               4      => (Value => 0, Next => 3),
               5      => (Value => 3, Next => 4),
               others => (Value => 0, Next => 0)));

   procedure Print_List (L : List) is
      J : Extended_Index;
   begin
      J := L.Head;
      while J /= No_Index loop
         Put_Line (Index'Image (J) & " =>" & Integer'Image (L.Raw(J).Value));
         J := L.Raw(J).Next;
      end loop;
   end Print_List;

   R : Extended_Index;
begin
   R := Search (L);

   Put_Line ("L ="); Print_List (L);
   Put_Line ("0 at position " & Extended_Index'Image (R));
end Main;

