with Ada.Text_IO; use Ada.Text_IO;
with Queens;      use Queens;

procedure Main is
   Success  : Boolean;
   Queens_2 : Board (1..2);
   Queens_4 : Board (1 .. 4);

   procedure Print_Board (B : Board) is
      J : Index;
   begin
      J := 1;
      while J <= B'Last loop
         Put_Line ("|" & Index'Image (B(J)));
         J := J + 1;
      end loop;
   end Print_Board;

begin
   -- 2-Queens
   Search (Queens_2, 2, Success);

   if (Success) then
      Put_Line ("The legal placement in Queens_2 is : ");
      Print_Board (Queens_2);
   else
      Put_Line ("No solution found in Queens_2");
   end if;

   New_Line;

   -- 4-Queens
   Search (Queens_4, 4, Success);

   if (Success) then
      Put_Line ("The legal placement in Queens_4 is : " );
      Print_Board (Queens_4);
   else
      Put_Line ("No solution found in Queens_4");
   end if;
end Main;

