with Ada.Text_IO;     use Ada.Text_IO;
with Amortized_Queue; use Amortized_Queue;

procedure Main is
   L : constant List :=
     (Head => 0,
      Raw  => No_Data,
      Free => 1,
      Size => 0);
   Q : Queue := (Front => L, Rear => L);

   procedure Print_List (L : List) is
      J : Extended_Index;
   begin
      J := L.Head;
      while J /= No_Index loop
         Put_Line (Index'Image (J) & " =>" & Integer'Image (L.Raw(J).Value));
         J := L.Raw(J).Next;
      end loop;
   end Print_List;

   procedure Print_Queue (Q : Queue) is
   begin
      Put_Line ("Front =");
      Print_List (Q.Front);
      Put_Line ("Rear =");
      Print_List (Q.Rear);
   end Print_Queue;

begin
   Q := Enqueue (Q, 1);
   Print_Queue (Q);
   Q := Enqueue (Q, 2);
   Print_Queue (Q);
   Q := Enqueue (Q, 3);
   Print_Queue (Q);
   Q := Enqueue (Q, 4);
   Print_Queue (Q);
   Q := Enqueue (Q, 5);
   Print_Queue (Q);

   Q := Tail (Q);
   Print_Queue (Q);
   Q := Tail (Q);
   Print_Queue (Q);
   Q := Tail (Q);
   Print_Queue (Q);
   Q := Tail (Q);
   Print_Queue (Q);
   Q := Tail (Q);
   Print_Queue (Q);
end Main;

